/*************************************************************************
                      Gauss_code..h

***************************************************************************/

#include <matrix.h>
#include <debug-control.h>
#include <generic-code.h>
#include <gauss-orientation.h>

typedef int code_term_type;

class Gauss_code
{
public:	
	vector<code_term_type> code;
	vector<int> num_terms_in_component;

	Gauss_code(int t, int c): code(vector<code_term_type>(t)),num_terms_in_component(vector<int>(c)){}	
	Gauss_code(string s, int num_terms, int num_components);	
	Gauss_code(generic_code_data code_data);	
	bool operator == (const Gauss_code& c) {return (this->code == c.code && this->num_terms_in_component == c.num_terms_in_component);}
	bool operator != (const Gauss_code& c) {return !(*this == c);}
};

void print_gauss_code(ostream& os, Gauss_code& g_code);
void write_gauss_code(ostream& os, Gauss_code& g_code, int n=0, bool raw_format=false);
void write_signed_code(ostream& os, Gauss_code& g_code);
vector<code_term_type> minimal_cyclic_code(Gauss_code& g_code);
